using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace XFileTrimPath
{
    public partial class MainForm : Form
    {
        /// <summary>
        /// RXgN^
        /// </summary>
        public MainForm()
        {
            InitializeComponent();
        }

        /// <summary>
        /// I{^Cxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonCancel_Click(object sender, EventArgs e)
        {
            Close();
        }


        /// <summary>
        /// Qƃ{^Cxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonFileRef_Click(object sender, EventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            if (dialog.ShowDialog(this) != DialogResult.OK)
            {
                return;
            }
            textFileName.Text = dialog.FileName;
        }

        /// <summary>
        /// ϊs܂
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonOk_Click(object sender, EventArgs e)
        {
            // pX`FbN
            if (textFileName.Text == "")
            {
                MessageBox.Show("t@Cݒ肵ĂB", "TrimPath", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            // t@Cǂݍ݂܂
            try
            {
                Cursor.Current = Cursors.WaitCursor;

                uint lineCount = 1;

                string newFileName = textFileName.Text + "_000.x";
                using (StreamWriter sw = new StreamWriter(newFileName, false))
                {
                    // sǂݍ݂܂
                    using (StreamReader sr = new StreamReader(textFileName.Text))
                    {
                        String line;
                        while ((line = sr.ReadLine()) != null)
                        {
                            String workLine = line;
                            workLine.ToLower();
                            int findIndex1 = workLine.LastIndexOf(".bmp");
                            int findIndex2 = workLine.LastIndexOf(".png");
                            int findIndex3 = workLine.LastIndexOf(".jpg");
                            int findIndex4 = workLine.LastIndexOf(".jpeg");

                            if (
                                (findIndex1 != -1) ||
                                (findIndex2 != -1) ||
                                (findIndex3 != -1) ||
                                (findIndex4 != -1)
                            )
                            {
                                string message;
                                message = "[" + lineCount + "]:" + line;
                                listboxResult.Items.Add(message);

                                // _uNH[g͂̕܂
                                line = TrimPath(line, textTransPath.Text);
                            }

                            // Vt@Cɏ݂܂
                            sw.WriteLine(line);

                            lineCount++;
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "TrimPath", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            MessageBox.Show("I܂B", "TrimPath", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        /// <summary>
        /// _uNH[g͂̕܂
        /// </summary>
        /// <param name="line">_uNH[e[VpX̓</param>
        /// <param name="transPathText">pXu</param>
        /// <returns>
        /// ϊ    pXg~Oꂽ
        /// ϊs    ŗ(̂܂)
        /// </returns>
        string TrimPath(string line, string transPathText)
        {
            // uppXݒ肳Ăۂ "\" ɂĂȂꍇ͕t܂
            if (transPathText.Length != 0)
            {
                if (transPathText[transPathText.Length - 1] != '\\')
                {
                    transPathText += "\\";
                }

                // "\"  "\\" ɕϊ܂
                string workPath = "";
                for (int i = 0; i < transPathText.Length; i++)
                {
                    if (transPathText[i] == '\\')
                    {
                        workPath += "\\";
                    }
                    workPath += transPathText[i];
                }
                transPathText = workPath;
            }

            // _uNH[gʒu
            int findIndex1 = line.IndexOf('\"');
            int findIndex2 = line.LastIndexOf('\"');
            if (findIndex1 == findIndex2)
            {
                return line;
            }

            // pX܂
            int findIndex3 = line.LastIndexOf('\\');
            if ((findIndex1 == -1) || (findIndex2 == -1) || (findIndex3 == -1))
            {
                return line;
            }

            // pX܂Ő؂Ďcq܂
            string result = line.Substring(0, findIndex1 + 1);
            result += transPathText;
            result += line.Substring(findIndex3 + 1);

            return result;
        }

        /// <summary>
        /// hbO & hbvCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void OnFormDragEnter(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.All;
        }

        /// <summary>
        /// hbO & hbvCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void OnFormDragDrop(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
            {
                // hbOꂽڂ̃t@Ct@Cɐݒ
                string[] fileName = (string[])e.Data.GetData(DataFormats.FileDrop);
                textFileName.Text = fileName[0];
            }
        }
    }
}